#ifndef _H_588A027EF9D57CEE815C1D8B9D64D8D3_MovingObjectsInFrame_DCPS_H_
#define _H_588A027EF9D57CEE815C1D8B9D64D8D3_MovingObjectsInFrame_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MovingObjectsInFrame_.h"


namespace object_analytics_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MovingObjectsInFrame_TypeSupportInterface;

            typedef MovingObjectsInFrame_TypeSupportInterface * MovingObjectsInFrame_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MovingObjectsInFrame_TypeSupportInterface> MovingObjectsInFrame_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MovingObjectsInFrame_TypeSupportInterface> MovingObjectsInFrame_TypeSupportInterface_out;


            class MovingObjectsInFrame_DataWriter;

            typedef MovingObjectsInFrame_DataWriter * MovingObjectsInFrame_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MovingObjectsInFrame_DataWriter> MovingObjectsInFrame_DataWriter_var;
            typedef DDS_DCPSInterface_out < MovingObjectsInFrame_DataWriter> MovingObjectsInFrame_DataWriter_out;


            class MovingObjectsInFrame_DataReader;

            typedef MovingObjectsInFrame_DataReader * MovingObjectsInFrame_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MovingObjectsInFrame_DataReader> MovingObjectsInFrame_DataReader_var;
            typedef DDS_DCPSInterface_out < MovingObjectsInFrame_DataReader> MovingObjectsInFrame_DataReader_out;


            class MovingObjectsInFrame_DataReaderView;

            typedef MovingObjectsInFrame_DataReaderView * MovingObjectsInFrame_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MovingObjectsInFrame_DataReaderView> MovingObjectsInFrame_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MovingObjectsInFrame_DataReaderView> MovingObjectsInFrame_DataReaderView_out;

            struct MovingObjectsInFrame_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MovingObjectsInFrame_, struct MovingObjectsInFrame_Seq_uniq_> MovingObjectsInFrame_Seq;
            typedef DDS_DCPSSequence_var < MovingObjectsInFrame_Seq> MovingObjectsInFrame_Seq_var;
            typedef DDS_DCPSSequence_out < MovingObjectsInFrame_Seq> MovingObjectsInFrame_Seq_out;

            class  MovingObjectsInFrame_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MovingObjectsInFrame_TypeSupportInterface_ptr _ptr_type;
                typedef MovingObjectsInFrame_TypeSupportInterface_var _var_type;

                static MovingObjectsInFrame_TypeSupportInterface_ptr _duplicate (MovingObjectsInFrame_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MovingObjectsInFrame_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MovingObjectsInFrame_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MovingObjectsInFrame_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MovingObjectsInFrame_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MovingObjectsInFrame_TypeSupportInterface () {};
                ~MovingObjectsInFrame_TypeSupportInterface () {};
            private:
                MovingObjectsInFrame_TypeSupportInterface (const MovingObjectsInFrame_TypeSupportInterface &);
                MovingObjectsInFrame_TypeSupportInterface & operator = (const MovingObjectsInFrame_TypeSupportInterface &);
            };

            class  MovingObjectsInFrame_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MovingObjectsInFrame_DataWriter_ptr _ptr_type;
                typedef MovingObjectsInFrame_DataWriter_var _var_type;

                static MovingObjectsInFrame_DataWriter_ptr _duplicate (MovingObjectsInFrame_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MovingObjectsInFrame_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MovingObjectsInFrame_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MovingObjectsInFrame_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MovingObjectsInFrame_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MovingObjectsInFrame_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MovingObjectsInFrame_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MovingObjectsInFrame_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MovingObjectsInFrame_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MovingObjectsInFrame_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MovingObjectsInFrame_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MovingObjectsInFrame_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MovingObjectsInFrame_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MovingObjectsInFrame_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MovingObjectsInFrame_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MovingObjectsInFrame_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MovingObjectsInFrame_& instance_data) = 0;

            protected:
                MovingObjectsInFrame_DataWriter () {};
                ~MovingObjectsInFrame_DataWriter () {};
            private:
                MovingObjectsInFrame_DataWriter (const MovingObjectsInFrame_DataWriter &);
                MovingObjectsInFrame_DataWriter & operator = (const MovingObjectsInFrame_DataWriter &);
            };

            class  MovingObjectsInFrame_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MovingObjectsInFrame_DataReader_ptr _ptr_type;
                typedef MovingObjectsInFrame_DataReader_var _var_type;

                static MovingObjectsInFrame_DataReader_ptr _duplicate (MovingObjectsInFrame_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MovingObjectsInFrame_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MovingObjectsInFrame_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MovingObjectsInFrame_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MovingObjectsInFrame_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MovingObjectsInFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MovingObjectsInFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MovingObjectsInFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MovingObjectsInFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MovingObjectsInFrame_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MovingObjectsInFrame_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MovingObjectsInFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MovingObjectsInFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MovingObjectsInFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MovingObjectsInFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MovingObjectsInFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MovingObjectsInFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MovingObjectsInFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MovingObjectsInFrame_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MovingObjectsInFrame_& instance) = 0;

            protected:
                MovingObjectsInFrame_DataReader () {};
                ~MovingObjectsInFrame_DataReader () {};
            private:
                MovingObjectsInFrame_DataReader (const MovingObjectsInFrame_DataReader &);
                MovingObjectsInFrame_DataReader & operator = (const MovingObjectsInFrame_DataReader &);
            };

            class  MovingObjectsInFrame_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MovingObjectsInFrame_DataReaderView_ptr _ptr_type;
                typedef MovingObjectsInFrame_DataReaderView_var _var_type;

                static MovingObjectsInFrame_DataReaderView_ptr _duplicate (MovingObjectsInFrame_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MovingObjectsInFrame_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MovingObjectsInFrame_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MovingObjectsInFrame_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MovingObjectsInFrame_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MovingObjectsInFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MovingObjectsInFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MovingObjectsInFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MovingObjectsInFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MovingObjectsInFrame_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MovingObjectsInFrame_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MovingObjectsInFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MovingObjectsInFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MovingObjectsInFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MovingObjectsInFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MovingObjectsInFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MovingObjectsInFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MovingObjectsInFrame_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MovingObjectsInFrame_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MovingObjectsInFrame_& instance) = 0;

            protected:
                MovingObjectsInFrame_DataReaderView () {};
                ~MovingObjectsInFrame_DataReaderView () {};
            private:
                MovingObjectsInFrame_DataReaderView (const MovingObjectsInFrame_DataReaderView &);
                MovingObjectsInFrame_DataReaderView & operator = (const MovingObjectsInFrame_DataReaderView &);
            };
        }

    }

}

#endif
