// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from object_analytics_msgs:msg/MovingObject.idl
// generated code does not contain a copyright notice

#ifndef OBJECT_ANALYTICS_MSGS__MSG__MOVING_OBJECT__STRUCT_HPP_
#define OBJECT_ANALYTICS_MSGS__MSG__MOVING_OBJECT__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'roi'
#include "sensor_msgs/msg/region_of_interest__struct.hpp"
// Member 'min'
// Member 'max'
#include "geometry_msgs/msg/point32__struct.hpp"
// Member 'velocity'
#include "geometry_msgs/msg/point__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__object_analytics_msgs__msg__MovingObject __attribute__((deprecated))
#else
# define DEPRECATED__object_analytics_msgs__msg__MovingObject __declspec(deprecated)
#endif

namespace object_analytics_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MovingObject_
{
  using Type = MovingObject_<ContainerAllocator>;

  explicit MovingObject_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : roi(_init),
    min(_init),
    max(_init),
    velocity(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
      this->type = "";
      this->probability = 0.0f;
    }
  }

  explicit MovingObject_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : type(_alloc),
    roi(_alloc, _init),
    min(_alloc, _init),
    max(_alloc, _init),
    velocity(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
      this->type = "";
      this->probability = 0.0f;
    }
  }

  // field types and members
  using _id_type =
    int32_t;
  _id_type id;
  using _type_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _type_type type;
  using _probability_type =
    float;
  _probability_type probability;
  using _roi_type =
    sensor_msgs::msg::RegionOfInterest_<ContainerAllocator>;
  _roi_type roi;
  using _min_type =
    geometry_msgs::msg::Point32_<ContainerAllocator>;
  _min_type min;
  using _max_type =
    geometry_msgs::msg::Point32_<ContainerAllocator>;
  _max_type max;
  using _velocity_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _velocity_type velocity;

  // setters for named parameter idiom
  Type & set__id(
    const int32_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__type(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->type = _arg;
    return *this;
  }
  Type & set__probability(
    const float & _arg)
  {
    this->probability = _arg;
    return *this;
  }
  Type & set__roi(
    const sensor_msgs::msg::RegionOfInterest_<ContainerAllocator> & _arg)
  {
    this->roi = _arg;
    return *this;
  }
  Type & set__min(
    const geometry_msgs::msg::Point32_<ContainerAllocator> & _arg)
  {
    this->min = _arg;
    return *this;
  }
  Type & set__max(
    const geometry_msgs::msg::Point32_<ContainerAllocator> & _arg)
  {
    this->max = _arg;
    return *this;
  }
  Type & set__velocity(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->velocity = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    object_analytics_msgs::msg::MovingObject_<ContainerAllocator> *;
  using ConstRawPtr =
    const object_analytics_msgs::msg::MovingObject_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<object_analytics_msgs::msg::MovingObject_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<object_analytics_msgs::msg::MovingObject_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      object_analytics_msgs::msg::MovingObject_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<object_analytics_msgs::msg::MovingObject_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      object_analytics_msgs::msg::MovingObject_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<object_analytics_msgs::msg::MovingObject_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<object_analytics_msgs::msg::MovingObject_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<object_analytics_msgs::msg::MovingObject_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__object_analytics_msgs__msg__MovingObject
    std::shared_ptr<object_analytics_msgs::msg::MovingObject_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__object_analytics_msgs__msg__MovingObject
    std::shared_ptr<object_analytics_msgs::msg::MovingObject_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MovingObject_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->type != other.type) {
      return false;
    }
    if (this->probability != other.probability) {
      return false;
    }
    if (this->roi != other.roi) {
      return false;
    }
    if (this->min != other.min) {
      return false;
    }
    if (this->max != other.max) {
      return false;
    }
    if (this->velocity != other.velocity) {
      return false;
    }
    return true;
  }
  bool operator!=(const MovingObject_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MovingObject_

// alias to use template instance with default allocator
using MovingObject =
  object_analytics_msgs::msg::MovingObject_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace object_analytics_msgs

#endif  // OBJECT_ANALYTICS_MSGS__MSG__MOVING_OBJECT__STRUCT_HPP_
