// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from object_analytics_msgs:msg/ObjectInBox3D.idl
// generated code does not contain a copyright notice
#include "object_analytics_msgs/msg/object_in_box3_d__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `object`
#include "object_msgs/msg/object__functions.h"
// Member `roi`
#include "sensor_msgs/msg/region_of_interest__functions.h"
// Member `min`
// Member `max`
#include "geometry_msgs/msg/point32__functions.h"

bool
object_analytics_msgs__msg__ObjectInBox3D__init(object_analytics_msgs__msg__ObjectInBox3D * msg)
{
  if (!msg) {
    return false;
  }
  // object
  if (!object_msgs__msg__Object__init(&msg->object)) {
    object_analytics_msgs__msg__ObjectInBox3D__fini(msg);
    return false;
  }
  // roi
  if (!sensor_msgs__msg__RegionOfInterest__init(&msg->roi)) {
    object_analytics_msgs__msg__ObjectInBox3D__fini(msg);
    return false;
  }
  // min
  if (!geometry_msgs__msg__Point32__init(&msg->min)) {
    object_analytics_msgs__msg__ObjectInBox3D__fini(msg);
    return false;
  }
  // max
  if (!geometry_msgs__msg__Point32__init(&msg->max)) {
    object_analytics_msgs__msg__ObjectInBox3D__fini(msg);
    return false;
  }
  return true;
}

void
object_analytics_msgs__msg__ObjectInBox3D__fini(object_analytics_msgs__msg__ObjectInBox3D * msg)
{
  if (!msg) {
    return;
  }
  // object
  object_msgs__msg__Object__fini(&msg->object);
  // roi
  sensor_msgs__msg__RegionOfInterest__fini(&msg->roi);
  // min
  geometry_msgs__msg__Point32__fini(&msg->min);
  // max
  geometry_msgs__msg__Point32__fini(&msg->max);
}

object_analytics_msgs__msg__ObjectInBox3D *
object_analytics_msgs__msg__ObjectInBox3D__create()
{
  object_analytics_msgs__msg__ObjectInBox3D * msg = (object_analytics_msgs__msg__ObjectInBox3D *)malloc(sizeof(object_analytics_msgs__msg__ObjectInBox3D));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(object_analytics_msgs__msg__ObjectInBox3D));
  bool success = object_analytics_msgs__msg__ObjectInBox3D__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
object_analytics_msgs__msg__ObjectInBox3D__destroy(object_analytics_msgs__msg__ObjectInBox3D * msg)
{
  if (msg) {
    object_analytics_msgs__msg__ObjectInBox3D__fini(msg);
  }
  free(msg);
}


bool
object_analytics_msgs__msg__ObjectInBox3D__Sequence__init(object_analytics_msgs__msg__ObjectInBox3D__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  object_analytics_msgs__msg__ObjectInBox3D * data = NULL;
  if (size) {
    data = (object_analytics_msgs__msg__ObjectInBox3D *)calloc(size, sizeof(object_analytics_msgs__msg__ObjectInBox3D));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = object_analytics_msgs__msg__ObjectInBox3D__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        object_analytics_msgs__msg__ObjectInBox3D__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
object_analytics_msgs__msg__ObjectInBox3D__Sequence__fini(object_analytics_msgs__msg__ObjectInBox3D__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      object_analytics_msgs__msg__ObjectInBox3D__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

object_analytics_msgs__msg__ObjectInBox3D__Sequence *
object_analytics_msgs__msg__ObjectInBox3D__Sequence__create(size_t size)
{
  object_analytics_msgs__msg__ObjectInBox3D__Sequence * array = (object_analytics_msgs__msg__ObjectInBox3D__Sequence *)malloc(sizeof(object_analytics_msgs__msg__ObjectInBox3D__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = object_analytics_msgs__msg__ObjectInBox3D__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
object_analytics_msgs__msg__ObjectInBox3D__Sequence__destroy(object_analytics_msgs__msg__ObjectInBox3D__Sequence * array)
{
  if (array) {
    object_analytics_msgs__msg__ObjectInBox3D__Sequence__fini(array);
  }
  free(array);
}
