// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from object_analytics_msgs:msg/TrackedObjects.idl
// generated code does not contain a copyright notice

#ifndef OBJECT_ANALYTICS_MSGS__MSG__TRACKED_OBJECTS__FUNCTIONS_H_
#define OBJECT_ANALYTICS_MSGS__MSG__TRACKED_OBJECTS__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_generator_c/visibility_control.h"
#include "object_analytics_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "object_analytics_msgs/msg/tracked_objects__struct.h"

/// Initialize msg/TrackedObjects message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * object_analytics_msgs__msg__TrackedObjects
 * )) before or use
 * object_analytics_msgs__msg__TrackedObjects__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_object_analytics_msgs
bool
object_analytics_msgs__msg__TrackedObjects__init(object_analytics_msgs__msg__TrackedObjects * msg);

/// Finalize msg/TrackedObjects message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_object_analytics_msgs
void
object_analytics_msgs__msg__TrackedObjects__fini(object_analytics_msgs__msg__TrackedObjects * msg);

/// Create msg/TrackedObjects message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * object_analytics_msgs__msg__TrackedObjects__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_object_analytics_msgs
object_analytics_msgs__msg__TrackedObjects *
object_analytics_msgs__msg__TrackedObjects__create();

/// Destroy msg/TrackedObjects message.
/**
 * It calls
 * object_analytics_msgs__msg__TrackedObjects__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_object_analytics_msgs
void
object_analytics_msgs__msg__TrackedObjects__destroy(object_analytics_msgs__msg__TrackedObjects * msg);


/// Initialize array of msg/TrackedObjects messages.
/**
 * It allocates the memory for the number of elements and calls
 * object_analytics_msgs__msg__TrackedObjects__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_object_analytics_msgs
bool
object_analytics_msgs__msg__TrackedObjects__Sequence__init(object_analytics_msgs__msg__TrackedObjects__Sequence * array, size_t size);

/// Finalize array of msg/TrackedObjects messages.
/**
 * It calls
 * object_analytics_msgs__msg__TrackedObjects__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_object_analytics_msgs
void
object_analytics_msgs__msg__TrackedObjects__Sequence__fini(object_analytics_msgs__msg__TrackedObjects__Sequence * array);

/// Create array of msg/TrackedObjects messages.
/**
 * It allocates the memory for the array and calls
 * object_analytics_msgs__msg__TrackedObjects__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_object_analytics_msgs
object_analytics_msgs__msg__TrackedObjects__Sequence *
object_analytics_msgs__msg__TrackedObjects__Sequence__create(size_t size);

/// Destroy array of msg/TrackedObjects messages.
/**
 * It calls
 * object_analytics_msgs__msg__TrackedObjects__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_object_analytics_msgs
void
object_analytics_msgs__msg__TrackedObjects__Sequence__destroy(object_analytics_msgs__msg__TrackedObjects__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // OBJECT_ANALYTICS_MSGS__MSG__TRACKED_OBJECTS__FUNCTIONS_H_
