// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from object_analytics_msgs:msg/TrackedObjects.idl
// generated code does not contain a copyright notice

#ifndef OBJECT_ANALYTICS_MSGS__MSG__TRACKED_OBJECTS__STRUCT_HPP_
#define OBJECT_ANALYTICS_MSGS__MSG__TRACKED_OBJECTS__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/header__struct.hpp"
// Member 'tracked_objects'
#include "object_analytics_msgs/msg/tracked_object__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__object_analytics_msgs__msg__TrackedObjects __attribute__((deprecated))
#else
# define DEPRECATED__object_analytics_msgs__msg__TrackedObjects __declspec(deprecated)
#endif

namespace object_analytics_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct TrackedObjects_
{
  using Type = TrackedObjects_<ContainerAllocator>;

  explicit TrackedObjects_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    (void)_init;
  }

  explicit TrackedObjects_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _tracked_objects_type =
    std::vector<object_analytics_msgs::msg::TrackedObject_<ContainerAllocator>, typename ContainerAllocator::template rebind<object_analytics_msgs::msg::TrackedObject_<ContainerAllocator>>::other>;
  _tracked_objects_type tracked_objects;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__tracked_objects(
    const std::vector<object_analytics_msgs::msg::TrackedObject_<ContainerAllocator>, typename ContainerAllocator::template rebind<object_analytics_msgs::msg::TrackedObject_<ContainerAllocator>>::other> & _arg)
  {
    this->tracked_objects = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    object_analytics_msgs::msg::TrackedObjects_<ContainerAllocator> *;
  using ConstRawPtr =
    const object_analytics_msgs::msg::TrackedObjects_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<object_analytics_msgs::msg::TrackedObjects_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<object_analytics_msgs::msg::TrackedObjects_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      object_analytics_msgs::msg::TrackedObjects_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<object_analytics_msgs::msg::TrackedObjects_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      object_analytics_msgs::msg::TrackedObjects_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<object_analytics_msgs::msg::TrackedObjects_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<object_analytics_msgs::msg::TrackedObjects_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<object_analytics_msgs::msg::TrackedObjects_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__object_analytics_msgs__msg__TrackedObjects
    std::shared_ptr<object_analytics_msgs::msg::TrackedObjects_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__object_analytics_msgs__msg__TrackedObjects
    std::shared_ptr<object_analytics_msgs::msg::TrackedObjects_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TrackedObjects_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->tracked_objects != other.tracked_objects) {
      return false;
    }
    return true;
  }
  bool operator!=(const TrackedObjects_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TrackedObjects_

// alias to use template instance with default allocator
using TrackedObjects =
  object_analytics_msgs::msg::TrackedObjects_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace object_analytics_msgs

#endif  // OBJECT_ANALYTICS_MSGS__MSG__TRACKED_OBJECTS__STRUCT_HPP_
