#ifndef _H_87164FA042C7FC4E5AFBA6BF0FC1D76F_MovingObject__H_
#define _H_87164FA042C7FC4E5AFBA6BF0FC1D76F_MovingObject__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "sensor_msgs/msg/dds_opensplice/RegionOfInterest_.h"
#include "geometry_msgs/msg/dds_opensplice/Point32_.h"
#include "geometry_msgs/msg/dds_opensplice/Point_.h"


namespace object_analytics_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  MovingObject_
            {
                ::DDS::Long id_;
                ::DDS::String_mgr type_;
                ::DDS::Float probability_;
                ::sensor_msgs::msg::dds_::RegionOfInterest_ roi_;
                ::geometry_msgs::msg::dds_::Point32_ min_;
                ::geometry_msgs::msg::dds_::Point32_ max_;
                ::geometry_msgs::msg::dds_::Point_ velocity_;
            };

            typedef DDS_DCPSStruct_var<MovingObject_> MovingObject__var;
            typedef DDS_DCPSStruct_out < MovingObject_> MovingObject__out;

        }

    }

}

#endif /* _H_87164FA042C7FC4E5AFBA6BF0FC1D76F_MovingObject__H_ */
