#ifndef _H_32D4E7F30E9D4C6A9E5B549B1CEF1405_ObjectsInBoxes3D_DCPS_H_
#define _H_32D4E7F30E9D4C6A9E5B549B1CEF1405_ObjectsInBoxes3D_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ObjectsInBoxes3D_.h"


namespace object_analytics_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ObjectsInBoxes3D_TypeSupportInterface;

            typedef ObjectsInBoxes3D_TypeSupportInterface * ObjectsInBoxes3D_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ObjectsInBoxes3D_TypeSupportInterface> ObjectsInBoxes3D_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ObjectsInBoxes3D_TypeSupportInterface> ObjectsInBoxes3D_TypeSupportInterface_out;


            class ObjectsInBoxes3D_DataWriter;

            typedef ObjectsInBoxes3D_DataWriter * ObjectsInBoxes3D_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ObjectsInBoxes3D_DataWriter> ObjectsInBoxes3D_DataWriter_var;
            typedef DDS_DCPSInterface_out < ObjectsInBoxes3D_DataWriter> ObjectsInBoxes3D_DataWriter_out;


            class ObjectsInBoxes3D_DataReader;

            typedef ObjectsInBoxes3D_DataReader * ObjectsInBoxes3D_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ObjectsInBoxes3D_DataReader> ObjectsInBoxes3D_DataReader_var;
            typedef DDS_DCPSInterface_out < ObjectsInBoxes3D_DataReader> ObjectsInBoxes3D_DataReader_out;


            class ObjectsInBoxes3D_DataReaderView;

            typedef ObjectsInBoxes3D_DataReaderView * ObjectsInBoxes3D_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ObjectsInBoxes3D_DataReaderView> ObjectsInBoxes3D_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ObjectsInBoxes3D_DataReaderView> ObjectsInBoxes3D_DataReaderView_out;

            struct ObjectsInBoxes3D_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ObjectsInBoxes3D_, struct ObjectsInBoxes3D_Seq_uniq_> ObjectsInBoxes3D_Seq;
            typedef DDS_DCPSSequence_var < ObjectsInBoxes3D_Seq> ObjectsInBoxes3D_Seq_var;
            typedef DDS_DCPSSequence_out < ObjectsInBoxes3D_Seq> ObjectsInBoxes3D_Seq_out;

            class  ObjectsInBoxes3D_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ObjectsInBoxes3D_TypeSupportInterface_ptr _ptr_type;
                typedef ObjectsInBoxes3D_TypeSupportInterface_var _var_type;

                static ObjectsInBoxes3D_TypeSupportInterface_ptr _duplicate (ObjectsInBoxes3D_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectsInBoxes3D_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ObjectsInBoxes3D_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectsInBoxes3D_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectsInBoxes3D_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ObjectsInBoxes3D_TypeSupportInterface () {};
                ~ObjectsInBoxes3D_TypeSupportInterface () {};
            private:
                ObjectsInBoxes3D_TypeSupportInterface (const ObjectsInBoxes3D_TypeSupportInterface &);
                ObjectsInBoxes3D_TypeSupportInterface & operator = (const ObjectsInBoxes3D_TypeSupportInterface &);
            };

            class  ObjectsInBoxes3D_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ObjectsInBoxes3D_DataWriter_ptr _ptr_type;
                typedef ObjectsInBoxes3D_DataWriter_var _var_type;

                static ObjectsInBoxes3D_DataWriter_ptr _duplicate (ObjectsInBoxes3D_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectsInBoxes3D_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ObjectsInBoxes3D_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectsInBoxes3D_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectsInBoxes3D_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ObjectsInBoxes3D_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ObjectsInBoxes3D_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ObjectsInBoxes3D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ObjectsInBoxes3D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ObjectsInBoxes3D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ObjectsInBoxes3D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ObjectsInBoxes3D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ObjectsInBoxes3D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ObjectsInBoxes3D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ObjectsInBoxes3D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ObjectsInBoxes3D_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObjectsInBoxes3D_& instance_data) = 0;

            protected:
                ObjectsInBoxes3D_DataWriter () {};
                ~ObjectsInBoxes3D_DataWriter () {};
            private:
                ObjectsInBoxes3D_DataWriter (const ObjectsInBoxes3D_DataWriter &);
                ObjectsInBoxes3D_DataWriter & operator = (const ObjectsInBoxes3D_DataWriter &);
            };

            class  ObjectsInBoxes3D_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ObjectsInBoxes3D_DataReader_ptr _ptr_type;
                typedef ObjectsInBoxes3D_DataReader_var _var_type;

                static ObjectsInBoxes3D_DataReader_ptr _duplicate (ObjectsInBoxes3D_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectsInBoxes3D_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ObjectsInBoxes3D_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectsInBoxes3D_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectsInBoxes3D_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ObjectsInBoxes3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObjectsInBoxes3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObjectsInBoxes3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObjectsInBoxes3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObjectsInBoxes3D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObjectsInBoxes3D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObjectsInBoxes3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObjectsInBoxes3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObjectsInBoxes3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObjectsInBoxes3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObjectsInBoxes3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObjectsInBoxes3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObjectsInBoxes3D_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObjectsInBoxes3D_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObjectsInBoxes3D_& instance) = 0;

            protected:
                ObjectsInBoxes3D_DataReader () {};
                ~ObjectsInBoxes3D_DataReader () {};
            private:
                ObjectsInBoxes3D_DataReader (const ObjectsInBoxes3D_DataReader &);
                ObjectsInBoxes3D_DataReader & operator = (const ObjectsInBoxes3D_DataReader &);
            };

            class  ObjectsInBoxes3D_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ObjectsInBoxes3D_DataReaderView_ptr _ptr_type;
                typedef ObjectsInBoxes3D_DataReaderView_var _var_type;

                static ObjectsInBoxes3D_DataReaderView_ptr _duplicate (ObjectsInBoxes3D_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectsInBoxes3D_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ObjectsInBoxes3D_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectsInBoxes3D_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectsInBoxes3D_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ObjectsInBoxes3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObjectsInBoxes3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObjectsInBoxes3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObjectsInBoxes3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObjectsInBoxes3D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObjectsInBoxes3D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObjectsInBoxes3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObjectsInBoxes3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObjectsInBoxes3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObjectsInBoxes3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObjectsInBoxes3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObjectsInBoxes3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObjectsInBoxes3D_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObjectsInBoxes3D_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObjectsInBoxes3D_& instance) = 0;

            protected:
                ObjectsInBoxes3D_DataReaderView () {};
                ~ObjectsInBoxes3D_DataReaderView () {};
            private:
                ObjectsInBoxes3D_DataReaderView (const ObjectsInBoxes3D_DataReaderView &);
                ObjectsInBoxes3D_DataReaderView & operator = (const ObjectsInBoxes3D_DataReaderView &);
            };
        }

    }

}

#endif
